#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFortuenTaskCFG.h"
std::auto_ptr<M_ActivityFortuenTaskCFG> M_ActivityFortuenTaskCFG::msSingleton(nullptr);

int M_ActivityFortuenTaskCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFortuenTaskCFGData* M_ActivityFortuenTaskCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFortuenTaskCFGData>& M_ActivityFortuenTaskCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityFortuenTaskCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFortuenTaskCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFortuenTaskCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mDesc = element->Attribute("Desc");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mDays = element->IntAttribute("Days");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFortuenTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFortuenTaskCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFortuenTaskCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFortuenTaskCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFortuenTaskCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readVectorInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readInt(L, "Days", data.mDays);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFortuenTaskCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFortuenTaskCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFortuenTaskCFG* M_ActivityFortuenTaskCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFortuenTaskCFG());
	}
	return msSingleton.get();
}

void M_ActivityFortuenTaskCFG::Release()
{
	msSingleton.reset(nullptr);
}
